package cn.ysk.cashier.service.shop;

import cn.ysk.cashier.dto.shop.TbShopStorageDto;
import cn.ysk.cashier.dto.shop.TbShopStorageNumDto;
import cn.ysk.cashier.dto.shop.TbShopStorageQueryCriteria;
import cn.ysk.cashier.pojo.shop.TbShopStorage;
import org.springframework.data.domain.Pageable;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * @author ww
 * @date 2024-05-21
 **/
public interface TbShopStorageService {

    /**
     * 查询数据分页
     * @param criteria 条件
     * @param pageable 分页参数
     * @return Map<String,Object>
     */
    Map<String,Object> queryAll(TbShopStorageQueryCriteria criteria, Pageable pageable);

    /**
     * 查询所有数据不分页
     * @param criteria 条件参数
     * @return List<TbShopStorageDto>
     */
    List<TbShopStorageDto> queryAll(TbShopStorageQueryCriteria criteria);

    Map<String,Object> countStorage(TbShopStorageQueryCriteria criteria,Pageable pageable);

    /**
     * 根据ID查询
     * @param id ID
     * @return TbShopStorageDto
     */
    TbShopStorageDto findById(Integer id);

    /**
     * 创建
     * @param resources /
     * @return TbShopStorageDto
     */
    TbShopStorageDto create(TbShopStorage resources);

    /**
     * 编辑
     * @param resources /
     */
    void update(TbShopStorage resources);

    void expStorage();

    void updateNum(TbShopStorageNumDto resources);

    /**
     * 多选删除
     * @param ids /
     */
    void deleteAll(Integer[] ids);

    /**
     * 导出数据
     * @param all 待导出的数据
     * @param response /
     * @throws IOException /
     */
    void download(List<TbShopStorageDto> all, HttpServletResponse response) throws IOException;
}